import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Rakete here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Rakete extends Animal
{
    private int anzahlTreffer = 0;
    private Ballon zielobjekt;
    
    private boolean inBewegung = false;
    /**
     * Act - do whatever the Rakete wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        tastaturAbfrage();
        fliegeNachOben();
        
    }    
    
    /**
     * Methode zur Steuerung der Tastaturabfrage. Der Anwender kann die
     * Rakete mit den Pfeiltasten nach links und rechts bewegen, mit den
     * Tasten y und x kann er die Raktete neigen und mit der Leertaste
     * kann er die Rakete abschießen.
     */
    public void tastaturAbfrage()
    {
        // Rakete abschiessen
        if (Greenfoot.isKeyDown("space")) {
            inBewegung = true;
        }
        
        // Rakete links/rechts bewegen
        if (Greenfoot.isKeyDown("left") && inBewegung == false) {
            setLocation(getX()-10,getY());
        }
        if (Greenfoot.isKeyDown("right") && inBewegung == false) {
            setLocation(getX()+10,getY());
        }
        
        // Rakete drehen
        if (Greenfoot.isKeyDown("y")) {
            if (getRotation() > 225) {
                turn(-1);
            }
        }
        if (Greenfoot.isKeyDown("x")) {
            if (getRotation() < 315) {
                turn(1);
            }
        }
                
        // Cheatmodus
        if (Greenfoot.isKeyDown("c")) {
            turnTowards(zielobjekt.getX(),zielobjekt.getY());
        }
    }
    
    /**
     * Methode für die Bewegung nach oben. Ist die Rakete abgeschossen worden,
     * so fliegt sie nach oben, bis sie entweder am oberen Rand ankommt oder auf
     * das Zielobjekt (den Ballon) getroffen ist. Im letzteren Fall werden die Punkte
     * hochgezählt und bei 10 erreichten Punkten die Anwendung gestoppt.
     */
    public void fliegeNachOben()
    {
        if (inBewegung == true) {
            move(5);            
        }
        if (hatGetroffen() == true) {
            anzahlTreffer++;
            zielobjekt.wechsleBild();
            if (anzahlTreffer == 10) {
                Greenfoot.stop();
            }
        }        
        if (obenAngekommen() == true || hatGetroffen() == true) {
            inBewegung = false;
            setLocation(getX(),350);
        }
    }
    
    /**
     * Methode überprüft, ob die Rakete am oberen Rand angekommen ist.
     */
    public boolean obenAngekommen() 
    {
        if (getY() <= 10) {
            return true;
        } else {
            return false;
        }
    }
    
    /**
     * Methode überprüft, ob ein Ballon getroffen wurde.
     */
    public boolean hatGetroffen()
    {
        if (getOneIntersectingObject(Ballon.class) != null) {
            return true;
        } else {
            return false;
        }
    }
    
    /**
     * Methode ermöglicht das Kennenlernen des Zielobjekts.
     */
    public void lerneBallonKennen(Ballon b)
    {
        zielobjekt = b;
    }
        
}
